package com.xx.xxviewlibrary.base;

import android.annotation.SuppressLint;
import android.content.Context;
import android.content.Intent;
import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;
import androidx.databinding.ViewDataBinding;
import androidx.lifecycle.LifecycleOwner;
import androidx.lifecycle.Observer;
import androidx.recyclerview.widget.RecyclerView;

import com.huantansheng.easyphotos.EasyPhotos;
import com.huantansheng.easyphotos.callback.SelectCallback;
import com.xx.xxviewlibrary.utils.GlideEngine;

import java.util.List;
import java.util.Map;


public abstract class xxBaseRecyclerViewAdapter<T extends ViewDataBinding,K> extends RecyclerView.Adapter<xxBaseRecyclerViewViewHolder<T>> {

    public Context mContext;
    public List<K> mList;
    public LifecycleOwner ownerl;

    public OnItemClick<K> itemClick;



    public xxBaseRecyclerViewAdapter(Context context) {
        try{
            ownerl= (LifecycleOwner) context;
        }catch (Exception e)
        {

        }

        mContext=context;
    }

    @NonNull
    @Override
    public xxBaseRecyclerViewViewHolder<T> onCreateViewHolder(@NonNull ViewGroup parent, int viewType) {

        View view= LayoutInflater.from(mContext).inflate(initLayout(),parent,false);

        return new xxBaseRecyclerViewViewHolder<T>(mContext,view);
    }

    @Override
    public void onBindViewHolder(@NonNull xxBaseRecyclerViewViewHolder<T> holder,  int position) {



        covert(holder.dataBind,mList.get(position),position);

        holder.dataBind.getRoot().setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                if (itemClick!=null)
                {
                    itemClick.itemClickCalBack(position,mList.get(position));
                }
            }
        });


    }



    @Override
    public int getItemCount() {
        return mList==null?0:mList.size();
    }

    public abstract int initLayout();


    protected abstract void covert(T dataBind, K data, int position);



    public void startPhoto(boolean hasCamera, SelectCallback callback)
    {
        EasyPhotos.createAlbum(AppManager.getAppManager().currentActivity(), hasCamera, false, GlideEngine.getInstance()).setCount(1)
                .start(callback);
    }

    public void  setOnItemClick(OnItemClick<K> click )
    {
        itemClick=click;
    }


    public interface OnItemClick<K>
    {
        void itemClickCalBack(int position,K data);
    }


}
