package com.xx.xxviewlibrary.witget

import android.content.Context
import android.content.res.TypedArray
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.widget.ImageButton
import android.widget.RelativeLayout
import android.widget.TextView
import androidx.databinding.BindingAdapter
import androidx.databinding.InverseBindingAdapter
import androidx.databinding.InverseBindingListener
import com.xx.xxviewlibrary.R

/**
 * 自定义titlebar
 */
class XxBar  constructor(activity: Context?, attrs: AttributeSet?) : RelativeLayout(activity, attrs, ){
    //标题
    @JvmField
    var tv_title: TextView? = null
    //左侧icon
    var img_left: ImageButton? = null

    var attrsArray:TypedArray?= null


    init {
        InitView(attrs)
    }



    companion object
    {

        @BindingAdapter("bar_title")
        @JvmStatic
        fun setBarTitle(view: XxBar, title:String)
        {
            view.tv_title?: return
            view.tv_title?.setText(title)
        }


        @InverseBindingAdapter(attribute ="bar_title")
        @JvmStatic
        fun getBarTitle(view: XxBar):String
        {
            return view.tv_title?.text.toString()
        }

        @BindingAdapter("bar_titleAttrChanged")
        @JvmStatic fun setListeners(
            view: XxBar,
            attrChange: InverseBindingListener
        ) {

        }

        @BindingAdapter("right_src")
        @JvmStatic
        fun setRightSrc(view: XxBar, title:Int)
        {
            view.tv_title?: return
            view.tv_title?.setText(title)
        }

        @BindingAdapter("on_click")
        @JvmStatic
        fun setOnCLick(view: XxBar, click:View.OnClickListener)
        {
            view.img_left?: return
            view.img_left?.setOnClickListener(click)
        }
    }



    fun InitView(attrs: AttributeSet?) {
        val view: View = LayoutInflater.from(context).inflate(R.layout.witget_bar, this, true)
        tv_title = view.findViewById<TextView>(R.id.bar_title)
        img_left = view.findViewById<ImageButton>(R.id.bar_left_icon)



    }





}